#file: map_screen.py
#Copyright (C) 2005 Free Software Foundation
#This file is part of Endgame: Singularity.

#Endgame: Singularity is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#Endgame: Singularity is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with Endgame: Singularity; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#This file is used to display the World Map.


import pygame
import g

import buttons
import scrollbar
import listbox
import main_menu

def display_pause_menu():
	xy_loc = (g.screen_size[0]/2 - 100, 50)

	#Border
	g.screen.fill(g.colors["blue"], (xy_loc[0], xy_loc[1], 200, 350))
	g.screen.fill(g.colors["black"], (xy_loc[0]+1, xy_loc[1]+1, 198, 348))
	menu_buttons = []
	menu_buttons.append(buttons.button((xy_loc[0]+10, xy_loc[1]+10), (180, 50),
		"RESUME", 0, g.colors["dark_blue"], g.colors["white"],
		g.colors["white"], g.font[1][30]))
	menu_buttons.append(buttons.button((xy_loc[0]+10, xy_loc[1]+80), (180, 50),
		"SAVE GAME", 0, g.colors["dark_blue"], g.colors["white"],
		g.colors["white"], g.font[1][30]))
	menu_buttons.append(buttons.button((xy_loc[0]+10, xy_loc[1]+150), (180, 50),
		"NEW GAME", 0, g.colors["dark_blue"], g.colors["white"],
		g.colors["white"], g.font[1][30]))
	menu_buttons.append(buttons.button((xy_loc[0]+10, xy_loc[1]+220), (180, 50),
		"LOAD GAME", 0, g.colors["dark_blue"], g.colors["white"],
		g.colors["white"], g.font[1][30]))
	menu_buttons.append(buttons.button((xy_loc[0]+10, xy_loc[1]+290), (180, 50),
		"QUIT", 0, g.colors["dark_blue"], g.colors["white"],
		g.colors["white"], g.font[1][30]))

	for button in menu_buttons:
		button.refresh_button()
	pygame.display.flip()

	while 1:
		g.clock.tick(60)
		for event in pygame.event.get():
			if event.type == pygame.QUIT: q.quit_game()
			elif event.type == pygame.KEYDOWN:
				if event.key == pygame.K_ESCAPE: return 0
				elif event.key == pygame.K_r: return 0
				elif event.key == pygame.K_s: return 1
				elif event.key == pygame.K_n: return 2
				elif event.key == pygame.K_l: return 3
				elif event.key == pygame.K_q: return 4
			elif event.type == pygame.MOUSEBUTTONUP:
				for button in menu_buttons:
					if button.is_over(event.pos):
						if button.text == "RESUME":
							return 0
						if button.text == "SAVE GAME":
							return 1
						if button.text == "NEW GAME":
							return 2
						elif button.text == "LOAD GAME":
							return 3
						if button.text == "QUIT":
							return 4


def map_loop():
	menu_buttons = []
	menu_buttons.append(buttons.button((100, 0), -1,
		"OPTIONS", 0, g.colors["dark_blue"], g.colors["white"],
		g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*15/100, g.screen_size[1]*25/100), -1,
			"N AMERICA", 0, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*20/100, g.screen_size[1]*50/100), -1,
			"S AMERICA", 0, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*45/100, g.screen_size[1]*30/100), -1,
			"EUROPE", 0, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*80/100, g.screen_size[1]*30/100), -1,
			"ASIA", 0, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*55/100, g.screen_size[1]*45/100), -1,
			"AFRICA", 3, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*50/100, g.screen_size[1]*75/100), -1,
			"ANTARCTIC", 2, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*70/100, g.screen_size[1]*60/100), -1,
			"OCEAN", 1, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*85/100, g.screen_size[1]*10/100), -1,
			"MOON", 0, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*15/100, g.screen_size[1]*10/100), -1,
			"ORBIT", 2, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*10/100, g.screen_size[1]*90/100), -1,
			"FAR REACHES", 0, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))
	menu_buttons.append(buttons.button((
			g.screen_size[0]*75/100, g.screen_size[1]*90/100), -1,
			"TRANSDIMENSIONAL", 1, g.colors["dark_blue"], g.colors["white"],
			g.colors["white"], g.font[1][25]))

	refresh_map(menu_buttons)

	while 1:
		g.clock.tick(60)
		for event in pygame.event.get():
			if event.type == pygame.QUIT: q.quit_game()
			elif event.type == pygame.KEYDOWN:
				if event.key == pygame.K_ESCAPE or \
							event.key == pygame.K_o:
					tmp = display_pause_menu()
					tmp = handle_pause_menu(tmp, menu_buttons)
					if tmp != -1: return tmp
			elif event.type == pygame.MOUSEBUTTONUP:
				for button in menu_buttons:
					if button.is_over(event.pos):
						if button.text == "OPTIONS":
							tmp = display_pause_menu()
							tmp = handle_pause_menu(tmp, menu_buttons)
							if tmp != -1: return tmp


def handle_pause_menu(tmp, menu_buttons):
	if tmp == 0: refresh_map(menu_buttons)
	elif tmp == 1: refresh_map(menu_buttons)
	elif tmp == 2: return 0
	elif tmp == 3:
		load_return = main_menu.display_load_menu()
		if load_return == -1:
			refresh_map(menu_buttons)
		else:
			print load_return
			g.quit_game()
	elif tmp == 4: g.quit_game()
	return -1

def refresh_map(menu_buttons):
	g.screen.fill(g.colors["black"])
	g.screen.blit(pygame.transform.scale(g.picts["earth.jpg"],
				(g.screen_size[0], g.screen_size[0]/2)), (0, g.screen_size[1]/2-g.screen_size[0]/4))
	for button in menu_buttons:
		button.refresh_button()
	pygame.display.flip()


